var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import range from 'lodash/range';

export var DATAGOVSG_COLORS = ['#C64D26', '#FF7733', '#415961', '#65828A', '#B2D0D8', '#DAE3E8'];

export function getScale() {
  return new Plottable.Scales.Linear().tickGenerator(getCustomTickGenerator());
}

export function getCategoryScale(type) {
  return new Plottable.Scales.Category().outerPadding(0.2);
}

export function getColorScale() {
  return new Plottable.Scales.Color().range(DATAGOVSG_COLORS);
}

export function getSingleColorScale() {
  var scale = new Plottable.Scales.Color().range([DATAGOVSG_COLORS[0]]);
  scale.scale = function (value) {
    return this._d3Scale(value);
  };
  return scale;
}

export function getTimeScale() {
  return new CustomTimeScale();
}

var CustomTimeScale = function (_Plottable$Scales$Tim) {
  _inherits(CustomTimeScale, _Plottable$Scales$Tim);

  function CustomTimeScale() {
    _classCallCheck(this, CustomTimeScale);

    return _possibleConstructorReturn(this, (CustomTimeScale.__proto__ || Object.getPrototypeOf(CustomTimeScale)).apply(this, arguments));
  }

  _createClass(CustomTimeScale, [{
    key: '_expandSingleValueDomain',
    value: function _expandSingleValueDomain(singleValueDomain) {
      var _singleValueDomain = singleValueDomain.map(function (v) {
        return v.toDate();
      });
      return _get(CustomTimeScale.prototype.__proto__ || Object.getPrototypeOf(CustomTimeScale.prototype), '_expandSingleValueDomain', this).call(this, _singleValueDomain);
    }
  }]);

  return CustomTimeScale;
}(Plottable.Scales.Time);

export function getCustomNumberFormatter(isPercentage) {
  if (isPercentage) {
    var _defaultFormatter = Plottable.Formatters.general(5);
    return function (v) {
      return _defaultFormatter(v) + '%';
    };
  }

  var defaultFormatter = Plottable.Formatters.shortScale();
  return function (v) {
    var formatted = defaultFormatter(v);
    if (formatted.indexOf('.') > -1) {
      formatted = formatted.replace(/\.?(0*|0{3}\d*)([KMBTQ]?)$/, '$2');
    }
    if (formatted === '-0') formatted = '0';
    return formatted;
  };
}

export function getCustomTickGenerator() {
  var targetLineCount = getCustomTickGenerator.targetLineCount || 4;
  return function (scale) {
    var _scale$domain = scale.domain(),
        _scale$domain2 = _slicedToArray(_scale$domain, 2),
        domainMin = _scale$domain2[0],
        domainMax = _scale$domain2[1];

    var domainRange = domainMax - domainMin;
    var nearestPower = Math.pow(10, Math.floor(Math.log(domainRange) / Math.LN10));
    var factor = domainRange / nearestPower / targetLineCount;
    factor = [2, 1, 0.5, 0.2].filter(function (v) {
      return v <= factor;
    })[0];
    var interval = nearestPower * (factor * 10) / 10;
    var firstTick = Math.ceil(domainMin / interval);
    var lastTick = Math.floor(domainMax / interval);
    return range(firstTick, lastTick + 1).map(function (v) {
      return v * interval;
    });
  };
}

export function getCustomTimeAxisConfigs(type) {
  switch (type) {
    case 'year':
    case 'financial_year':
      return yearConfigs();
    case 'half_year':
    case 'financial_half_year':
      return [].concat(_toConsumableArray(halfYearConfigs()), _toConsumableArray(yearConfigs()));
    case 'quarter':
    case 'financial_quarter':
      return [].concat(_toConsumableArray(quarterConfigs()), _toConsumableArray(yearConfigs()));
    case 'month':
      return [].concat(_toConsumableArray(monthConfigs()), _toConsumableArray(yearConfigs()));
    case 'week':
      return [].concat(_toConsumableArray(weekConfigs()), _toConsumableArray(yearConfigs()));
    case 'date':
      return [].concat(_toConsumableArray(dateConfigs()), _toConsumableArray(monthConfigs()), _toConsumableArray(yearConfigs()));
    case 'date_time':
      return [].concat(_toConsumableArray(dateTimeConfigs()), _toConsumableArray(dateConfigs()), _toConsumableArray(monthConfigs()), _toConsumableArray(yearConfigs()));
    case 'time':
      return timeConfigs();
  }
}

var yearSteps = [1, 5, 10, 25, 50, 100, 200, 500, 1000];

function yearConfigs() {
  return yearSteps.map(function (step) {
    return [{
      interval: Plottable.TimeInterval.year,
      step: step,
      formatter: Plottable.Formatters.time('%Y')
    }];
  });
}

function halfYearConfigs() {
  return [[{
    interval: Plottable.TimeInterval.month,
    step: 6,
    formatter: function formatter(d) {
      var date = new Date(d);
      return 'H' + Math.floor(date.getMonth() / 6) + 1;
    }
  }, {
    interval: Plottable.TimeInterval.year,
    step: 1,
    formatter: Plottable.Formatters.time('%Y')
  }]];
}

function quarterConfigs() {
  return [[{
    interval: Plottable.TimeInterval.month,
    step: 3,
    formatter: function formatter(d) {
      var date = new Date(d);
      return 'Q' + Math.floor(date.getMonth() / 3) + 1;
    }
  }, {
    interval: Plottable.TimeInterval.year,
    step: 1,
    formatter: Plottable.Formatters.time('%Y')
  }]];
}

// use the month steps in the orginal plottable library
function monthConfigs() {
  return [[{
    interval: Plottable.TimeInterval.month,
    step: 1,
    // full month name
    formatter: Plottable.Formatters.time('%B')
  }, {
    interval: Plottable.TimeInterval.year,
    step: 1,
    formatter: Plottable.Formatters.time('%Y')
  }], [{
    interval: Plottable.TimeInterval.month,
    step: 1,
    // short month name
    formatter: Plottable.Formatters.time('%b')
  }, {
    interval: Plottable.TimeInterval.year,
    step: 1,
    formatter: Plottable.Formatters.time('%Y')
  }], [{
    interval: Plottable.TimeInterval.month,
    step: 1,
    // month in numbers
    formatter: Plottable.Formatters.time('%m')
  }, {
    interval: Plottable.TimeInterval.year,
    step: 1,
    formatter: Plottable.Formatters.time('%Y')
  }], [{
    interval: Plottable.TimeInterval.month,
    step: 1,
    // month in numbers
    formatter: Plottable.Formatters.time('%-m')
  }, {
    interval: Plottable.TimeInterval.year,
    step: 1,
    formatter: Plottable.Formatters.time('%Y')
  }]];
}

function weekConfigs() {
  return [[{
    interval: Plottable.TimeInterval.week,
    step: 1,
    formatter: function formatter(date) {
      // same as the formatter in d3 but start from W1 instead of W0
      // week starts on monday
      return 'W' + d3.time.mondayOfYear(date) + 1;
    }
  }, {
    interval: Plottable.TimeInterval.year,
    step: 1,
    formatter: Plottable.Formatters.time('%Y')
  }]];
}

function dateConfigs() {
  return [[{
    interval: Plottable.TimeInterval.day,
    step: 1,
    formatter: Plottable.Formatters.time('%e')
  }, {
    interval: Plottable.TimeInterval.year,
    step: 1,
    formatter: Plottable.Formatters.time('%Y')
  }]];
}

var hourSteps = [1, 3, 6, 12];
var timeSteps = [1, 5, 10, 15, 30];

function dateTimeConfigs() {
  var configs = [];

  hourSteps.forEach(function (step) {
    // hours
    configs.push([{
      interval: Plottable.TimeInterval.hour,
      step: step,
      formatter: Plottable.Formatters.time('%I %p')
    }, { interval: Plottable.TimeInterval.day,
      step: 1,
      formatter: Plottable.Formatters.time('%B %e, %Y')
    }]);
  });
  timeSteps.forEach(function (step) {
    // minutes
    configs.push([{
      interval: Plottable.TimeInterval.minute,
      step: step,
      formatter: Plottable.Formatters.time('%I:%M %p')
    }, { interval: Plottable.TimeInterval.day,
      step: 1,
      formatter: Plottable.Formatters.time('%B %e, %Y')
    }]);
    // seconds
    configs.push([{
      interval: Plottable.TimeInterval.second,
      step: step,
      formatter: Plottable.Formatters.time('%I:%M:%S %p')
    }, { interval: Plottable.TimeInterval.day,
      step: 1,
      formatter: Plottable.Formatters.time('%B %e, %Y')
    }]);
  });

  return configs;
}

function timeConfigs() {
  var configs = [];

  hourSteps.forEach(function (step) {
    // hours
    configs.push([{
      interval: Plottable.TimeInterval.hour,
      step: step,
      formatter: Plottable.Formatters.time('%I %p')
    }]);
  });

  timeSteps.forEach(function (step) {
    // minutes
    configs.push([{
      interval: Plottable.TimeInterval.minute,
      step: step,
      formatter: Plottable.Formatters.time('%I:%M %p')
    }]);
    // seconds
    configs.push([{
      interval: Plottable.TimeInterval.second,
      step: step,
      formatter: Plottable.Formatters.time('%I:%M:%S %p')
    }]);
  });

  return configs;
}