function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import SimplePie from './components/SimplePie';
import SimpleBar from './components/SimpleBar';
import GroupedBar from './components/GroupedBar';
import StackedBar from './components/StackedBar';
import MultipleLine from './components/MultipleLine';

import { setupOuterLabel, removeInnerPadding, downsampleTicks, customizeTimeAxis } from './plugins';

import { getScale, getCategoryScale, getTimeScale, getColorScale, getSingleColorScale, getCustomNumberFormatter } from './helpers';

export { SimplePie, SimpleBar, GroupedBar, StackedBar, MultipleLine };

export var DatagovsgSimplePie = function (_SimplePie) {
  _inherits(DatagovsgSimplePie, _SimplePie);

  function DatagovsgSimplePie(props) {
    _classCallCheck(this, DatagovsgSimplePie);

    props = Object.assign({
      colorScale: getColorScale()
    }, props);

    var _this = _possibleConstructorReturn(this, (DatagovsgSimplePie.__proto__ || Object.getPrototypeOf(DatagovsgSimplePie)).call(this, props));

    setupOuterLabel(_this, { labelFormatter: function labelFormatter(d) {
        return d.label;
      } });
    return _this;
  }

  return DatagovsgSimplePie;
}(SimplePie);

export var DatagovsgSimpleBar = function (_SimpleBar) {
  _inherits(DatagovsgSimpleBar, _SimpleBar);

  function DatagovsgSimpleBar(props) {
    _classCallCheck(this, DatagovsgSimpleBar);

    props = Object.assign({
      scale: getScale(),
      categoryScale: props.isTimeSeries ? getTimeScale() : getCategoryScale(),
      colorScale: getSingleColorScale(),
      showGridlines: true
    }, props);

    var _this2 = _possibleConstructorReturn(this, (DatagovsgSimpleBar.__proto__ || Object.getPrototypeOf(DatagovsgSimpleBar)).call(this, props));

    downsampleTicks(_this2);
    customizeTimeAxis(_this2, props.isTimeSeries);

    postprocess(_this2.xAxis, _this2.yAxis, props);
    return _this2;
  }

  return DatagovsgSimpleBar;
}(SimpleBar);

export var DatagovsgHorizontalBar = function (_SimpleBar2) {
  _inherits(DatagovsgHorizontalBar, _SimpleBar2);

  function DatagovsgHorizontalBar(props) {
    _classCallCheck(this, DatagovsgHorizontalBar);

    props = Object.assign({
      orientation: 'h',
      sorted: 'd',
      scale: getScale(),
      categoryScale: getCategoryScale(),
      colorScale: getSingleColorScale(),
      showGridlines: true
    }, props);

    var _this3 = _possibleConstructorReturn(this, (DatagovsgHorizontalBar.__proto__ || Object.getPrototypeOf(DatagovsgHorizontalBar)).call(this, props));

    postprocess(_this3.yAxis, _this3.xAxis, props);
    _this3.xAxis.tickLabelPadding(0);
    return _this3;
  }

  return DatagovsgHorizontalBar;
}(SimpleBar);

export var DatagovsgGroupedBar = function (_GroupedBar) {
  _inherits(DatagovsgGroupedBar, _GroupedBar);

  function DatagovsgGroupedBar(props) {
    _classCallCheck(this, DatagovsgGroupedBar);

    props = Object.assign({
      scale: getScale(),
      categoryScale: props.isTimeSeries ? getTimeScale() : getCategoryScale(),
      colorScale: getColorScale(),
      showGridlines: true
    }, props);

    var _this4 = _possibleConstructorReturn(this, (DatagovsgGroupedBar.__proto__ || Object.getPrototypeOf(DatagovsgGroupedBar)).call(this, props));

    downsampleTicks(_this4);
    removeInnerPadding(_this4);
    customizeTimeAxis(_this4, props.isTimeSeries);

    postprocess(_this4.xAxis, _this4.yAxis, props);
    return _this4;
  }

  return DatagovsgGroupedBar;
}(GroupedBar);

export var DatagovsgStackedBar = function (_StackedBar) {
  _inherits(DatagovsgStackedBar, _StackedBar);

  function DatagovsgStackedBar(props) {
    _classCallCheck(this, DatagovsgStackedBar);

    props = Object.assign({
      scale: getScale(),
      categoryScale: props.isTimeSeries ? getTimeScale() : getCategoryScale(),
      colorScale: getColorScale(),
      showGridlines: true
    }, props);

    var _this5 = _possibleConstructorReturn(this, (DatagovsgStackedBar.__proto__ || Object.getPrototypeOf(DatagovsgStackedBar)).call(this, props));

    downsampleTicks(_this5);
    removeInnerPadding(_this5);
    customizeTimeAxis(_this5, props.isTimeSeries);

    postprocess(_this5.xAxis, _this5.yAxis, props);
    return _this5;
  }

  return DatagovsgStackedBar;
}(StackedBar);

export var DatagovsgLine = function (_MultipleLine) {
  _inherits(DatagovsgLine, _MultipleLine);

  function DatagovsgLine(props) {
    _classCallCheck(this, DatagovsgLine);

    props = Object.assign({
      yScale: getScale(),
      xScale: props.isTimeSeries ? getTimeScale() : getCategoryScale(),
      colorScale: getColorScale(),
      showYgridlines: true,
      guideLine: 'v'
    }, props);

    var _this6 = _possibleConstructorReturn(this, (DatagovsgLine.__proto__ || Object.getPrototypeOf(DatagovsgLine)).call(this, props));

    downsampleTicks(_this6);
    customizeTimeAxis(_this6, props.isTimeSeries);

    postprocess(_this6.xAxis, _this6.yAxis, props);
    return _this6;
  }

  return DatagovsgLine;
}(MultipleLine);

function postprocess(primaryAxis, secondaryAxis) {
  var props = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

  primaryAxis.margin(12).innerTickLength(5).endTickLength(5).tickLabelPadding(5);
  secondaryAxis.margin(12).innerTickLength(0).endTickLength(0).tickLabelPadding(5).showEndTickLabels(true).addClass('hide-baseline').formatter(getCustomNumberFormatter(props.isPercentage));
  // hack to show end tick labels
  secondaryAxis._hideOverflowingTickLabels = function () {
    return null;
  };
}