'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DatagovsgLine = exports.DatagovsgStackedBar = exports.DatagovsgGroupedBar = exports.DatagovsgHorizontalBar = exports.DatagovsgSimpleBar = exports.DatagovsgSimplePie = exports.MultipleLine = exports.StackedBar = exports.GroupedBar = exports.SimpleBar = exports.SimplePie = undefined;

var _SimplePie2 = require('./components/SimplePie');

var _SimplePie3 = _interopRequireDefault(_SimplePie2);

var _SimpleBar3 = require('./components/SimpleBar');

var _SimpleBar4 = _interopRequireDefault(_SimpleBar3);

var _GroupedBar2 = require('./components/GroupedBar');

var _GroupedBar3 = _interopRequireDefault(_GroupedBar2);

var _StackedBar2 = require('./components/StackedBar');

var _StackedBar3 = _interopRequireDefault(_StackedBar2);

var _MultipleLine2 = require('./components/MultipleLine');

var _MultipleLine3 = _interopRequireDefault(_MultipleLine2);

var _plugins = require('./plugins');

var _helpers = require('./helpers');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

exports.SimplePie = _SimplePie3.default;
exports.SimpleBar = _SimpleBar4.default;
exports.GroupedBar = _GroupedBar3.default;
exports.StackedBar = _StackedBar3.default;
exports.MultipleLine = _MultipleLine3.default;

var DatagovsgSimplePie = exports.DatagovsgSimplePie = function (_SimplePie) {
  _inherits(DatagovsgSimplePie, _SimplePie);

  function DatagovsgSimplePie(props) {
    _classCallCheck(this, DatagovsgSimplePie);

    props = Object.assign({
      colorScale: (0, _helpers.getColorScale)()
    }, props);

    var _this = _possibleConstructorReturn(this, (DatagovsgSimplePie.__proto__ || Object.getPrototypeOf(DatagovsgSimplePie)).call(this, props));

    (0, _plugins.setupOuterLabel)(_this, { labelFormatter: function labelFormatter(d) {
        return d.label;
      } });
    return _this;
  }

  return DatagovsgSimplePie;
}(_SimplePie3.default);

var DatagovsgSimpleBar = exports.DatagovsgSimpleBar = function (_SimpleBar) {
  _inherits(DatagovsgSimpleBar, _SimpleBar);

  function DatagovsgSimpleBar(props) {
    _classCallCheck(this, DatagovsgSimpleBar);

    props = Object.assign({
      scale: (0, _helpers.getScale)(),
      categoryScale: props.isTimeSeries ? (0, _helpers.getTimeScale)() : (0, _helpers.getCategoryScale)(),
      colorScale: (0, _helpers.getSingleColorScale)(),
      showGridlines: true
    }, props);

    var _this2 = _possibleConstructorReturn(this, (DatagovsgSimpleBar.__proto__ || Object.getPrototypeOf(DatagovsgSimpleBar)).call(this, props));

    (0, _plugins.downsampleTicks)(_this2);
    (0, _plugins.customizeTimeAxis)(_this2, props.isTimeSeries);

    postprocess(_this2.xAxis, _this2.yAxis, props);
    return _this2;
  }

  return DatagovsgSimpleBar;
}(_SimpleBar4.default);

var DatagovsgHorizontalBar = exports.DatagovsgHorizontalBar = function (_SimpleBar2) {
  _inherits(DatagovsgHorizontalBar, _SimpleBar2);

  function DatagovsgHorizontalBar(props) {
    _classCallCheck(this, DatagovsgHorizontalBar);

    props = Object.assign({
      orientation: 'h',
      sorted: 'd',
      scale: (0, _helpers.getScale)(),
      categoryScale: (0, _helpers.getCategoryScale)(),
      colorScale: (0, _helpers.getSingleColorScale)(),
      showGridlines: true
    }, props);

    var _this3 = _possibleConstructorReturn(this, (DatagovsgHorizontalBar.__proto__ || Object.getPrototypeOf(DatagovsgHorizontalBar)).call(this, props));

    postprocess(_this3.yAxis, _this3.xAxis, props);
    _this3.xAxis.tickLabelPadding(0);
    return _this3;
  }

  return DatagovsgHorizontalBar;
}(_SimpleBar4.default);

var DatagovsgGroupedBar = exports.DatagovsgGroupedBar = function (_GroupedBar) {
  _inherits(DatagovsgGroupedBar, _GroupedBar);

  function DatagovsgGroupedBar(props) {
    _classCallCheck(this, DatagovsgGroupedBar);

    props = Object.assign({
      scale: (0, _helpers.getScale)(),
      categoryScale: props.isTimeSeries ? (0, _helpers.getTimeScale)() : (0, _helpers.getCategoryScale)(),
      colorScale: (0, _helpers.getColorScale)(),
      showGridlines: true
    }, props);

    var _this4 = _possibleConstructorReturn(this, (DatagovsgGroupedBar.__proto__ || Object.getPrototypeOf(DatagovsgGroupedBar)).call(this, props));

    (0, _plugins.downsampleTicks)(_this4);
    (0, _plugins.removeInnerPadding)(_this4);
    (0, _plugins.customizeTimeAxis)(_this4, props.isTimeSeries);

    postprocess(_this4.xAxis, _this4.yAxis, props);
    return _this4;
  }

  return DatagovsgGroupedBar;
}(_GroupedBar3.default);

var DatagovsgStackedBar = exports.DatagovsgStackedBar = function (_StackedBar) {
  _inherits(DatagovsgStackedBar, _StackedBar);

  function DatagovsgStackedBar(props) {
    _classCallCheck(this, DatagovsgStackedBar);

    props = Object.assign({
      scale: (0, _helpers.getScale)(),
      categoryScale: props.isTimeSeries ? (0, _helpers.getTimeScale)() : (0, _helpers.getCategoryScale)(),
      colorScale: (0, _helpers.getColorScale)(),
      showGridlines: true
    }, props);

    var _this5 = _possibleConstructorReturn(this, (DatagovsgStackedBar.__proto__ || Object.getPrototypeOf(DatagovsgStackedBar)).call(this, props));

    (0, _plugins.downsampleTicks)(_this5);
    (0, _plugins.removeInnerPadding)(_this5);
    (0, _plugins.customizeTimeAxis)(_this5, props.isTimeSeries);

    postprocess(_this5.xAxis, _this5.yAxis, props);
    return _this5;
  }

  return DatagovsgStackedBar;
}(_StackedBar3.default);

var DatagovsgLine = exports.DatagovsgLine = function (_MultipleLine) {
  _inherits(DatagovsgLine, _MultipleLine);

  function DatagovsgLine(props) {
    _classCallCheck(this, DatagovsgLine);

    props = Object.assign({
      yScale: (0, _helpers.getScale)(),
      xScale: props.isTimeSeries ? (0, _helpers.getTimeScale)() : (0, _helpers.getCategoryScale)(),
      colorScale: (0, _helpers.getColorScale)(),
      showYgridlines: true,
      guideLine: 'v'
    }, props);

    var _this6 = _possibleConstructorReturn(this, (DatagovsgLine.__proto__ || Object.getPrototypeOf(DatagovsgLine)).call(this, props));

    (0, _plugins.downsampleTicks)(_this6);
    (0, _plugins.customizeTimeAxis)(_this6, props.isTimeSeries);

    postprocess(_this6.xAxis, _this6.yAxis, props);
    return _this6;
  }

  return DatagovsgLine;
}(_MultipleLine3.default);

function postprocess(primaryAxis, secondaryAxis) {
  var props = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

  primaryAxis.margin(12).innerTickLength(5).endTickLength(5).tickLabelPadding(5);
  secondaryAxis.margin(12).innerTickLength(0).endTickLength(0).tickLabelPadding(5).showEndTickLabels(true).addClass('hide-baseline').formatter((0, _helpers.getCustomNumberFormatter)(props.isPercentage));
  // hack to show end tick labels
  secondaryAxis._hideOverflowingTickLabels = function () {
    return null;
  };
}